/////////////////////////////////////////////////
/* a class to store an array of ones and zeros */
/////////////////////////////////////////////////

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "defines.h"
#include "bitvector.h"

/* constructor (given the size of the bitvector) */
BitVector::BitVector(unsigned n, VECTOR_DATA_TYPE *ptr, bool copymem)
{
	num = n;
	num_set = 0;
#if (MAX_NUM_GOODS > INT_BITS)
	int_num = num/INT_BITS + (num%INT_BITS?1:0);
	array = new VECTOR_DATA_TYPE[int_num];
	if (copymem) 
#else
	int_num = 1;
	assert (num<=INT_BITS);
#endif
	reset();
}

/* destructor */
BitVector::~BitVector()
{
#if (MAX_NUM_GOODS > INT_BITS)
	delete[] array;
#endif
}


